diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java
index 96fa28c72..6fbd9ad9e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntityActivator;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.ISupportable;
 import net.minecraft.core.block.support.PartialSupport;
@@ -14,12 +14,14 @@ import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 import java.util.Random;
 
@@ -36,12 +38,12 @@ public class BlockLogicButton
     public static final int SIDE_BOTTOM = 6;
 
     public BlockLogicButton(final @NotNull Block<?> block) {
-        super(block, Material.decoration);
+        super(block, Materials.DECORATION);
         block.setTicking(true);
     }
 
     @Override
-    public @Nullable AABB getCollisionAABB(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public @Nullable AABBdc getCollisionAABB(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         return null;
     }
 
@@ -61,18 +63,18 @@ public class BlockLogicButton
     }
 
     @Override
-    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side) {
+    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         return PartialSupport.INSTANCE;
     }
 
     @Override
-    public boolean canPlaceOnSide(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side) {
+    public boolean canPlaceOnSide(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         final @NotNull Side checkSide = side.getOpposite();
         return this.isSupported(world, tilePos, checkSide);
     }
 
     @Override
-    public boolean canPlaceAt(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public boolean canPlaceAt(final @NotNull World world, final @NotNull TilePosc tilePos) {
         return this.isSupported(world, tilePos, Side.BOTTOM)
             || this.isSupported(world, tilePos, Side.TOP)
             || this.isSupported(world, tilePos, Side.NORTH)
@@ -82,7 +84,7 @@ public class BlockLogicButton
     }
 
     @Override
-    public void onPlacedByMob(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final @NotNull Mob mob, final double xHit, final double yHit) {
+    public void onPlacedByMob(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final @NotNull Mob mob, final double xHit, final double yHit) {
         int orientation = -1;
         switch (side) {
             case BOTTOM:
@@ -126,7 +128,7 @@ public class BlockLogicButton
     }
 
     @Override
-    public void onPlacedOnSide(final @NotNull World world, final @NotNull TilePos tilePos, @NotNull Side side, final double xHit, final double yHit) {
+    public void onPlacedOnSide(final @NotNull World world, final @NotNull TilePosc tilePos, @NotNull Side side, final double xHit, final double yHit) {
         int orientation = -1;
         if (side.isHorizontal()) {
             side = side.getOpposite();
@@ -172,7 +174,7 @@ public class BlockLogicButton
         }
     }
 
-    private int getOrientation(final @NotNull World world, final @NotNull TilePos tilePos) {
+    private int getOrientation(final @NotNull World world, final @NotNull TilePosc tilePos) {
         if (this.isSupported(world, tilePos, Side.WEST)) {
             return SIDE_WEST;
         }
@@ -195,7 +197,7 @@ public class BlockLogicButton
     }
 
     @Override
-    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePos tilePos, final int id) {
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id) {
         final boolean invalid;
         final int meta = world.getBlockData(tilePos);
         final int side = meta & MASK_DIRECTION;
@@ -215,32 +217,32 @@ public class BlockLogicButton
     }
 
     @Override
-    public @NotNull AABB getBoundsFromState(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public @NotNull AABBdc getBoundsFromState(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         final int meta = source.getBlockData(tilePos);
         final int direction = meta & MASK_DIRECTION;
         final boolean powered = (meta & MASK_POWERED) != 0;
-        final float bottom = 0.375F;
-        final float top = 0.625F;
-        final float halfWidth = 0.1875F;
-        final float depth;
+        final double bottom = 0.375;
+        final double top = 0.625;
+        final double halfWidth = 0.1875;
+        final double depth;
         if (powered) {
-            depth = 0.0625F;
+            depth = 0.0625;
         } else {
-            depth = 0.125F;
+            depth = 0.125;
         }
         return switch (direction) {
-            case SIDE_WEST -> AABB.fromPool(0.0F, bottom, 0.5F - halfWidth, depth, top, 0.5F + halfWidth);
-            case SIDE_EAST -> AABB.fromPool(1.0F - depth, bottom, 0.5F - halfWidth, 1.0F, top, 0.5F + halfWidth);
-            case SIDE_NORTH -> AABB.fromPool(0.5F - halfWidth, bottom, 0.0F, 0.5F + halfWidth, top, depth);
-            case SIDE_SOUTH -> AABB.fromPool(0.5F - halfWidth, bottom, 1.0F - depth, 0.5F + halfWidth, top, 1.0F);
-            case SIDE_TOP -> AABB.fromPool(0.5f - halfWidth, 1 - depth, bottom, 0.5f + halfWidth, 1.0, top);
-            case SIDE_BOTTOM -> AABB.fromPool(0.5f - halfWidth, 0, bottom, 0.5f + halfWidth, depth, top);
+            case SIDE_WEST -> new AABBd(0.0, bottom, 0.5 - halfWidth, depth, top, 0.5 + halfWidth);
+            case SIDE_EAST -> new AABBd(1.0 - depth, bottom, 0.5 - halfWidth, 1.0, top, 0.5F + halfWidth);
+            case SIDE_NORTH -> new AABBd(0.5 - halfWidth, bottom, 0.0, 0.5F + halfWidth, top, depth);
+            case SIDE_SOUTH -> new AABBd(0.5 - halfWidth, bottom, 1.0 - depth, 0.5 + halfWidth, top, 1.0);
+            case SIDE_TOP -> new AABBd(0.5 - halfWidth, 1 - depth, bottom, 0.5 + halfWidth, 1.0, top);
+            case SIDE_BOTTOM -> new AABBd(0.5 - halfWidth, 0, bottom, 0.5 + halfWidth, depth, top);
             default -> super.getBoundsFromState(source, tilePos);
         };
     }
 
     @Override
-    public void onAttacked(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Player player, final @NotNull Side side, final double xHit, final double yHit) {
+    public void onAttacked(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Player player, final @NotNull Side side, final double xHit, final double yHit) {
         if (!Item.hasTag(player.getCurrentEquippedItem(), ItemTags.PREVENT_LEFT_CLICK_INTERACTIONS)) {
             this.onInteracted(world, tilePos, player, null, 0.0, 0.0);
         }
@@ -248,11 +250,11 @@ public class BlockLogicButton
 
 
     @Override
-    public boolean onInteracted(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Player player, final @Nullable Side side, final double xHit, final double yHit) {
+    public boolean onInteracted(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Player player, final @Nullable Side side, final double xHit, final double yHit) {
         return this.press(world, tilePos, player);
     }
 
-    private boolean press(final @NotNull World world, final @NotNull TilePos tilePos, final @Nullable Player player) {
+    private boolean press(final @NotNull World world, final @NotNull TilePosc tilePos, final @Nullable Player player) {
         final int meta = world.getBlockData(tilePos);
         final int direction = meta & MASK_DIRECTION;
         final boolean isPowered = (meta & MASK_POWERED) != 0;
@@ -261,27 +263,27 @@ public class BlockLogicButton
         }
         world.setBlockDataNotify(tilePos, (meta & ~MASK_DIRECTION) | direction | MASK_POWERED);
         world.markBlockDirty(tilePos);
-        world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, tilePos.x + 0.5D, tilePos.y + 0.5D, tilePos.z + 0.5D, "random.click", 0.3F, 0.6F);
+        world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, tilePos.x() + 0.5D, tilePos.y() + 0.5D, tilePos.z() + 0.5D, "random.click", 0.3F, 0.6F);
         world.notifyBlocksOfNeighborChange(tilePos, this.block.id());
 
         switch (direction) {
             case SIDE_WEST:
-                world.notifyBlocksOfNeighborChange(tilePos.west(), this.block.id());
+                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.WEST, new TilePos()), this.block.id());
                 break;
             case SIDE_EAST:
-                world.notifyBlocksOfNeighborChange(tilePos.east(), this.block.id());
+                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.EAST, new TilePos()), this.block.id());
                 break;
             case SIDE_NORTH:
-                world.notifyBlocksOfNeighborChange(tilePos.north(), this.block.id());
+                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.NORTH, new TilePos()), this.block.id());
                 break;
             case SIDE_SOUTH:
-                world.notifyBlocksOfNeighborChange(tilePos.south(), this.block.id());
+                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.SOUTH, new TilePos()), this.block.id());
                 break;
             case SIDE_TOP:
-                world.notifyBlocksOfNeighborChange(tilePos.up(), this.block.id());
+                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.UP, new TilePos()), this.block.id());
                 break;
             case SIDE_BOTTOM:
-                world.notifyBlocksOfNeighborChange(tilePos.down(), this.block.id());
+                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.DOWN, new TilePos()), this.block.id());
                 break;
         }
         world.scheduleBlockUpdate(tilePos, this.block.id(), this.tickDelay());
@@ -289,33 +291,33 @@ public class BlockLogicButton
     }
 
     @Override
-    public void onActivatorInteracted(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull TileEntityActivator activator, final @NotNull Direction direction) {
+    public void onActivatorInteracted(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull TileEntityActivator activator, final @NotNull Direction direction) {
         this.press(world, tilePos, null);
     }
 
     @Override
-    public void onRemoved(final @NotNull World world, final @NotNull TilePos tilePos, final int data) {
+    public void onRemoved(final @NotNull World world, final @NotNull TilePosc tilePos, final int data) {
         if ((data & MASK_POWERED) != 0) {
             world.notifyBlocksOfNeighborChange(tilePos, this.block.id());
             final int direction = data & MASK_DIRECTION;
             switch (direction) {
                 case SIDE_WEST:
-                    world.notifyBlocksOfNeighborChange(tilePos.west(), this.block.id());
+                    world.notifyBlocksOfNeighborChange(tilePos.add(Direction.WEST, new TilePos()), this.block.id());
                     break;
                 case SIDE_EAST:
-                    world.notifyBlocksOfNeighborChange(tilePos.east(), this.block.id());
+                    world.notifyBlocksOfNeighborChange(tilePos.add(Direction.EAST, new TilePos()), this.block.id());
                     break;
                 case SIDE_NORTH:
-                    world.notifyBlocksOfNeighborChange(tilePos.north(), this.block.id());
+                    world.notifyBlocksOfNeighborChange(tilePos.add(Direction.NORTH, new TilePos()), this.block.id());
                     break;
                 case SIDE_SOUTH:
-                    world.notifyBlocksOfNeighborChange(tilePos.south(), this.block.id());
+                    world.notifyBlocksOfNeighborChange(tilePos.add(Direction.SOUTH, new TilePos()), this.block.id());
                     break;
                 case SIDE_TOP:
-                    world.notifyBlocksOfNeighborChange(tilePos.up(), this.block.id());
+                    world.notifyBlocksOfNeighborChange(tilePos.add(Direction.UP, new TilePos()), this.block.id());
                     break;
                 case SIDE_BOTTOM:
-                    world.notifyBlocksOfNeighborChange(tilePos.down(), this.block.id());
+                    world.notifyBlocksOfNeighborChange(tilePos.add(Direction.DOWN, new TilePos()), this.block.id());
                     break;
             }
         }
@@ -323,12 +325,12 @@ public class BlockLogicButton
     }
 
     @Override
-    public boolean isEmittingSignal(final @NotNull WorldSource source, final @NotNull TilePos tilePos, final @NotNull Side side) {
+    public boolean isEmittingSignal(final @NotNull WorldSource source, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         return (source.getBlockData(tilePos) & MASK_POWERED) != 0;
     }
 
     @Override
-    public boolean isEmittingDirectSignal(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side) {
+    public boolean isEmittingDirectSignal(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         final int meta = world.getBlockData(tilePos);
         if ((meta & MASK_POWERED) == 0) {
             return false;
@@ -351,7 +353,7 @@ public class BlockLogicButton
     }
 
     @Override
-    public void updateTick(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Random rand, final boolean isRandomTick) {
+    public void updateTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand, final boolean isRandomTick) {
         if (world.isClientSide) {
             return;
         }
@@ -364,26 +366,26 @@ public class BlockLogicButton
         final int direction = meta & MASK_DIRECTION;
         switch (direction) {
             case SIDE_WEST:
-                world.notifyBlocksOfNeighborChange(tilePos.west(), this.block.id());
+                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.WEST, new TilePos()), this.block.id());
                 break;
             case SIDE_EAST:
-                world.notifyBlocksOfNeighborChange(tilePos.east(), this.block.id());
+                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.EAST, new TilePos()), this.block.id());
                 break;
             case SIDE_NORTH:
-                world.notifyBlocksOfNeighborChange(tilePos.north(), this.block.id());
+                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.NORTH, new TilePos()), this.block.id());
                 break;
             case SIDE_SOUTH:
-                world.notifyBlocksOfNeighborChange(tilePos.south(), this.block.id());
+                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.SOUTH, new TilePos()), this.block.id());
                 break;
             case SIDE_TOP:
-                world.notifyBlocksOfNeighborChange(tilePos.up(), this.block.id());
+                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.UP, new TilePos()), this.block.id());
                 break;
             case SIDE_BOTTOM:
-                world.notifyBlocksOfNeighborChange(tilePos.down(), this.block.id());
+                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.DOWN, new TilePos()), this.block.id());
                 break;
         }
 
-        world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, tilePos.x + 0.5D, tilePos.y + 0.5D, tilePos.z + 0.5D, "random.click", 0.3F, 0.5F);
+        world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, tilePos.x() + 0.5D, tilePos.y() + 0.5D, tilePos.z() + 0.5D, "random.click", 0.3F, 0.5F);
         world.markBlockDirty(tilePos);
     }
 
@@ -393,7 +395,7 @@ public class BlockLogicButton
     }
 
     @Override
-    public void setColor(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull DyeColor color) {
+    public void setColor(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull DyeColor color) {
         final int meta = world.getBlockData(tilePos);
         world.setBlockIdDataRaw(tilePos, Blocks.BUTTON_PLANKS_PAINTED.id(), meta);
         world.setBlockData(tilePos, meta);
@@ -404,7 +406,7 @@ public class BlockLogicButton
     }
 
     @Override
-    public @NotNull ISupport getSupportConstraint(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side) {
+    public @NotNull ISupport getSupportConstraint(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         return PartialSupport.INSTANCE.center();
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPainted.java
index 34307f3b3..333592202 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPainted.java
@@ -7,7 +7,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -46,12 +46,12 @@ public class BlockLogicButtonPainted
     }
 
     @Override
-    public void removeDye(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public void removeDye(final @NotNull World world, final @NotNull TilePosc tilePos) {
         world.setBlockIdNotify(tilePos, Blocks.BUTTON_PLANKS.id());
     }
 
     @Override
-    public int getPlacedData(final @Nullable Player player, final @NotNull ItemStack itemStack, final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final double xHit, final double yHit) {
+    public int getPlacedData(final @Nullable Player player, final @NotNull ItemStack itemStack, final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
         return itemStack.getMetadata() & MASK_COLOR;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPlanks.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPlanks.java
index e2dee7856..b9cc614dd 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPlanks.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPlanks.java
@@ -13,7 +13,6 @@ import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.NotNull;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java
index 615c54ad1..76c0777c7 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.support.FullSupport;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.block.tag.BlockTags;
@@ -12,11 +12,12 @@ import net.minecraft.core.entity.vehicle.EntityMinecart;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.IBonemealable;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -27,7 +28,7 @@ public class BlockLogicCactus
     implements IBonemealable {
 
     public BlockLogicCactus(final @NotNull Block<?> block) {
-        super(block, Material.cactus);
+        super(block, Materials.CACTUS);
         block.setTicking(true);
 
         final float indent = 0.0625F;
@@ -35,22 +36,23 @@ public class BlockLogicCactus
     }
 
     @Override
-    public void onPlacedByWorld(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public void onPlacedByWorld(final @NotNull World world, final @NotNull TilePosc tilePos) {
         this.onNeighborChanged(world, tilePos, 0);
     }
 
     @Override
-    public void updateTick(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Random rand, final boolean isRandomTick) {
-        if (world.isAirBlock(tilePos.up())) {
+    public void updateTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand, final boolean isRandomTick) {
+        TilePos queryPos = new TilePos();
+        if (world.isAirBlock(tilePos.add(Direction.UP, queryPos))) {
             int cactusHeight;
             cactusHeight = 1;
-            while (world.getBlockId(tilePos.sub(0, cactusHeight, 0)) == this.block.id()) {
+            while (world.getBlockId(tilePos.sub(0, cactusHeight, 0, queryPos)) == this.block.id()) {
                 cactusHeight++;
             }
             if (cactusHeight < 3) {
                 final int data = world.getBlockData(tilePos);
                 if (data == 15) {
-                    world.setBlockIdNotify(tilePos.up(), this.block.id());
+                    world.setBlockIdNotify(tilePos.add(Direction.UP, queryPos), this.block.id());
                     world.setBlockDataNotify(tilePos, 0);
                 } else {
                     world.setBlockDataNotify(tilePos, data + 1);
@@ -59,10 +61,11 @@ public class BlockLogicCactus
         }
     }
 
-    private void growCactusOnTop(final @NotNull World world, final @NotNull TilePos tilePos) {
+    private void growCactusOnTop(final @NotNull World world, final @NotNull TilePosc tilePos) {
         final @NotNull TilePos offsetPos = new TilePos(tilePos);
 
-        for (offsetPos.y = tilePos.y + 1; world.getBlockId(offsetPos) == this.block.id(); offsetPos.y++) { }
+        for (offsetPos.y = tilePos.y() + 1; world.getBlockId(offsetPos) == this.block.id(); offsetPos.y++) {
+        }
 
         if (world.isAirBlock(offsetPos)) {
             world.setBlockIdNotify(offsetPos, this.block.id());
@@ -80,7 +83,7 @@ public class BlockLogicCactus
     }
 
     @Override
-    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side) {
+    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         if (side.isVertical()) {
             return PartialSupport.INSTANCE.center();
         } else {
@@ -89,7 +92,7 @@ public class BlockLogicCactus
     }
 
     @Override
-    public boolean canPlaceAt(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public boolean canPlaceAt(final @NotNull World world, final @NotNull TilePosc tilePos) {
         if (!super.canPlaceAt(world, tilePos)) {
             return false;
         } else {
@@ -98,7 +101,7 @@ public class BlockLogicCactus
     }
 
     @Override
-    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePos tilePos, final int id) {
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id) {
         if (!this.canStay(world, tilePos)) {
             this.dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
             world.setBlockIdNotify(tilePos, 0);
@@ -106,33 +109,34 @@ public class BlockLogicCactus
     }
 
     @Override
-    public boolean canStay(final @NotNull World world, final @NotNull TilePos tilePos) {
-        if (world.getBlockMaterial(tilePos.west()).isSolid()) {
+    public boolean canStay(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        TilePos queryPos = new TilePos();
+        if (world.getBlockMaterial(tilePos.add(Direction.WEST, queryPos)).isSolid()) {
             return false;
         }
-        if (world.getBlockMaterial(tilePos.east()).isSolid()) {
+        if (world.getBlockMaterial(tilePos.add(Direction.EAST, queryPos)).isSolid()) {
             return false;
         }
-        if (world.getBlockMaterial(tilePos.north()).isSolid()) {
+        if (world.getBlockMaterial(tilePos.add(Direction.NORTH, queryPos)).isSolid()) {
             return false;
         }
-        if (world.getBlockMaterial(tilePos.south()).isSolid()) {
+        if (world.getBlockMaterial(tilePos.add(Direction.SOUTH, queryPos)).isSolid()) {
             return false;
         } else {
-            final int idDown = world.getBlockId(tilePos.down());
+            final int idDown = world.getBlockId(tilePos.add(Direction.DOWN, queryPos));
             return Blocks.hasTag(idDown, BlockTags.GROWS_CACTI);
         }
     }
 
     @Override
-    public void onEntityCollision(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Entity entity) {
+    public void onEntityCollision(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Entity entity) {
         if (entity instanceof Mob || entity instanceof EntityMinecart || entity instanceof EntityBoat) {
             entity.hurt(null, 1, DamageType.COMBAT);
         }
     }
 
     @Override
-    public boolean onBonemealUsed(final @NotNull ItemStack itemStack, final @Nullable Player player, final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side, final double xHit, final double yHit) {
+    public boolean onBonemealUsed(final @NotNull ItemStack itemStack, final @Nullable Player player, final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
         if (!world.isClientSide) {
             this.growCactusOnTop(world, tilePos);
             if (player == null || player.getGamemode().consumeBlocks()) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCake.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCake.java
index 32c7b2f2e..ea78bc289 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCake.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCake.java
@@ -1,11 +1,12 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.item.Items;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 public class BlockLogicCake extends BlockLogicEdible {
 
@@ -14,17 +15,17 @@ public class BlockLogicCake extends BlockLogicEdible {
     }
 
     @Override
-    public @NotNull AABB getBoundsFromState(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public @NotNull AABBdc getBoundsFromState(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         final int data = source.getBlockData(tilePos);
         final float gap = 0.0625f;
         final float width = (1 + data * 2) / 16.0f;
         final float height = 0.5f;
 
-        return AABB.fromPool(width, 0.0f, gap, 1.0f - gap, height, 1.0f - gap);
+        return new AABBd(width, 0.0f, gap, 1.0f - gap, height, 1.0f - gap);
     }
 
     @Override
-    public int getHealAmount(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public int getHealAmount(final @NotNull World world, final @NotNull TilePosc tilePos) {
         return 3;
     }
 }
